/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ConversationMessagesList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationMessagesList{}

// ConversationMessagesList struct for ConversationMessagesList
type ConversationMessagesList struct {
	Results []ConversationMessage `json:"results,omitempty"`
}

// NewConversationMessagesList instantiates a new ConversationMessagesList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationMessagesList() *ConversationMessagesList {
	this := ConversationMessagesList{}
	return &this
}

// NewConversationMessagesListWithDefaults instantiates a new ConversationMessagesList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationMessagesListWithDefaults() *ConversationMessagesList {
	this := ConversationMessagesList{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *ConversationMessagesList) GetResults() []ConversationMessage {
	if o == nil || IsNil(o.Results) {
		var ret []ConversationMessage
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessagesList) GetResultsOk() ([]ConversationMessage, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *ConversationMessagesList) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []ConversationMessage and assigns it to the Results field.
func (o *ConversationMessagesList) SetResults(v []ConversationMessage) {
	o.Results = v
}

func (o ConversationMessagesList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationMessagesList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	return toSerialize, nil
}

type NullableConversationMessagesList struct {
	value *ConversationMessagesList
	isSet bool
}

func (v NullableConversationMessagesList) Get() *ConversationMessagesList {
	return v.value
}

func (v *NullableConversationMessagesList) Set(val *ConversationMessagesList) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationMessagesList) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationMessagesList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationMessagesList(val *ConversationMessagesList) *NullableConversationMessagesList {
	return &NullableConversationMessagesList{value: val, isSet: true}
}

func (v NullableConversationMessagesList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationMessagesList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


